
; HI-TECH Software PICC Assembler header file.
; Definitions based on C header file: pic1674.h.

; NOTE: PICC assembler option -P is required to preprocess assembler sources. 

; Special Function Register definitions
TMR0		equ	001h
PCL		equ	002h
STATUS		equ	003h
FSR		equ	004h
PORTA		equ	005h
PORTB		equ	006h
PORTC		equ	007h
PCLATH		equ	00Ah
INTCON		equ	00Bh
PIR1		equ	00Ch
PIR2		equ	00Dh
TMR1L		equ	00Eh
TMR1H		equ	00Fh
T1CON		equ	010h
TMR2		equ	011h
T2CON		equ	012h
SSPBUF		equ	013h
SSPCON		equ	014h
CCPR1L		equ	015h
CCPR1H		equ	016h
CCP1CON		equ	017h
RCSTA		equ	018h
TXREG		equ	019h
RCREG		equ	01Ah
CCPR2L		equ	01Bh
CCPR2H		equ	01Ch
CCP2CON		equ	01Dh
ADRES		equ	01Eh
ADCON0		equ	01Fh
OPTION		equ	081h
TRISA		equ	085h
TRISB		equ	086h
TRISC		equ	087h
TRISD		equ	088h
TRISE		equ	089h
PIE1		equ	08Ch
PIE2		equ	08Dh
PCON		equ	08Eh
PR2		equ	092h
SSPADD		equ	093h
SSPSTAT		equ	094h
TXSTA		equ	098h
SPBRG		equ	099h
ADCON1		equ	09Fh
PORTD		equ	008h
PORTE		equ	009h

; Bit variables associates within SFRs
#define RP0	unsigned)
#define TO	unsigned)
#define PD	unsigned)
#define ZERO	unsigned)
#define DC	unsigned)
#define CARRY	unsigned)
#define RA5	unsigned)
#define RA4	unsigned)
#define RA3	unsigned)
#define RA2	unsigned)
#define RA1	unsigned)
#define RA0	unsigned)
#define RB7	unsigned)
#define RB6	unsigned)
#define RB5	unsigned)
#define RB4	unsigned)
#define RB3	unsigned)
#define RB2	unsigned)
#define RB1	unsigned)
#define RB0	unsigned)
#define RC7	unsigned)
#define RC6	unsigned)
#define RC5	unsigned)
#define RC4	unsigned)
#define RC3	unsigned)
#define RC2	unsigned)
#define RC1	unsigned)
#define RC0	unsigned)
#define RD7	unsigned)
#define RD6	unsigned)
#define RD5	unsigned)
#define RD4	unsigned)
#define RD3	unsigned)
#define RD2	unsigned)
#define RD1	unsigned)
#define RD0	unsigned)
#define RE2	unsigned)
#define RE1	unsigned)
#define RE0	unsigned)
#define GIE	unsigned)
#define PEIE	unsigned)
#define T0IE	unsigned)
#define INTE	unsigned)
#define RBIE	unsigned)
#define T0IF	unsigned)
#define INTF	unsigned)
#define RBIF	unsigned)
#define PSPIF	unsigned)
#define ADIF	unsigned)
#define RCIF	unsigned)
#define TXIF	unsigned)
#define SSPIF	unsigned)
#define CCP1IF	unsigned)
#define TMR2IF	unsigned)
#define TMR1IF	unsigned)
#define CCP2IF	unsigned)
#define T1CKPS1	unsigned)
#define T1CKPS0	unsigned)
#define T1OSCEN	unsigned)
#define T1SYNC	unsigned)
#define TMR1CS	unsigned)
#define TMR1ON	unsigned)
#define TOUTPS3	unsigned)
#define TOUTPS2	unsigned)
#define TOUTPS1	unsigned)
#define TOUTPS0	unsigned)
#define TMR2ON	unsigned)
#define T2CKPS1	unsigned)
#define T2CKPS0	unsigned)
#define WCOL	unsigned)
#define SSPOV	unsigned)
#define SSPEN	unsigned)
#define CKP	unsigned)
#define SSPM3	unsigned)
#define SSPM2	unsigned)
#define SSPM1	unsigned)
#define SSPM0	unsigned)
#define CCP1X	unsigned)
#define CCP1Y	unsigned)
#define CCP1M3	unsigned)
#define CCP1M2	unsigned)
#define CCP1M1	unsigned)
#define CCP1M0	unsigned)
#define SPEN	unsigned)
#define RX9	unsigned)
#define SREN	unsigned)
#define CREN	unsigned)
#define FERR	unsigned)
#define OERR	unsigned)
#define RX9D	unsigned)
#define CCP2X	unsigned)
#define CCP2Y	unsigned)
#define CCP2M3	unsigned)
#define CCP2M2	unsigned)
#define CCP2M1	unsigned)
#define CCP2M0	unsigned)
#define ADCS1	unsigned)
#define ADCS0	unsigned)
#define CHS2	unsigned)
#define CHS1	unsigned)
#define CHS0	unsigned)
#define ADGO	unsigned)
#define GODONE	unsigned)
#define ADON	unsigned)
#define RBPU	unsigned)
#define INTEDG	unsigned)
#define T0CS	unsigned)
#define T0SE	unsigned)
#define PSA	unsigned)
#define PS2	unsigned)
#define PS1	unsigned)
#define PS0	unsigned)
#define TRISA5	unsigned)
#define TRISA4	unsigned)
#define TRISA3	unsigned)
#define TRISA2	unsigned)
#define TRISA1	unsigned)
#define TRISA0	unsigned)
#define TRISB7	unsigned)
#define TRISB6	unsigned)
#define TRISB5	unsigned)
#define TRISB4	unsigned)
#define TRISB3	unsigned)
#define TRISB2	unsigned)
#define TRISB1	unsigned)
#define TRISB0	unsigned)
#define TRISC7	unsigned)
#define TRISC6	unsigned)
#define TRISC5	unsigned)
#define TRISC4	unsigned)
#define TRISC3	unsigned)
#define TRISC2	unsigned)
#define TRISC1	unsigned)
#define TRISC0	unsigned)
#define TRISD7	unsigned)
#define TRISD6	unsigned)
#define TRISD5	unsigned)
#define TRISD4	unsigned)
#define TRISD3	unsigned)
#define TRISD2	unsigned)
#define TRISD1	unsigned)
#define TRISD0	unsigned)
#define IBF	unsigned)
#define OBF	unsigned)
#define IBOV	unsigned)
#define PSPMODE	unsigned)
#define TRISE2	unsigned)
#define TRISE1	unsigned)
#define TRISE0	unsigned)
#define PSPIE	unsigned)
#define ADIE	unsigned)
#define RCIE	unsigned)
#define TXIE	unsigned)
#define SSPIE	unsigned)
#define CCP1IE	unsigned)
#define TMR2IE	unsigned)
#define TMR1IE	unsigned)
#define CCP2IE	unsigned)
#define POR	unsigned)
#define BOR	unsigned)
#define SMP	unsigned)
#define CKE	unsigned)
#define DA	unsigned)
#define STOP	unsigned)
#define START	unsigned)
#define RW	unsigned)
#define UA	unsigned)
#define BF	unsigned)
#define CSRC	unsigned)
#define TX9	unsigned)
#define TXEN	unsigned)
#define SYNC	unsigned)
#define BRGH	unsigned)
#define TRMT	unsigned)
#define TX9D	unsigned)
#define PCFG2	unsigned)
#define PCFG1	unsigned)
#define PCFG0	unsigned)
