#ifndef BATCH_DEBUG_H
#define BATCH_DEBUG_H

/*************************************************************************/
/*  				PIC Midrange				 */
/*************************************************************************/
#define	___mkstr1(x)	#x
#define	___mkstr(x)	___mkstr1(x)

#if defined(_PIC14)
#define _EXIT_SIM(exitCode)	do { \
					asm("dw " ___mkstr(0x3000 \
						+ (exitCode & 0xff))); \
					asm("dw 0Fh"); \
				} while(0);

#endif	/* PIC Midrange */

/*************************************************************************/
/*  				PIC18					 */
/*************************************************************************/
#if defined(_PIC18)
#define _EXIT_SIM(exitCode)	do { \
					asm("dw " ___mkstr(0xE00 \
						+ (exitCode & 0xff))); \
					asm("dw 01h"); \
				} while(0);
#endif	/* PIC 18 */

/*************************************************************************/
/*  				Common					 */
/*************************************************************************/

#if defined(_PIC18) || defined(_PIC14)

#define _PASSED_TESTS()	_EXIT_SIM(0);
#define _FAILED_TEST()	_EXIT_SIM(1);

#endif

#endif /* BATCH_DEBUG_H */
