
#ifndef	_HTC_H_
#warning Header file pic1655x.h included directly. Use #include <htc.h> instead.
#endif

/* 	
 *	Header file for the Microchip :
 *	PIC 16C554 chip
 *	PIC 16C554A chip
 *	PIC 16C556 chip
 *	PIC 16C556A chip
 *	PIC 16C557 chip
 *	PIC 16C558 chip
 *	PIC 16C558A chip
 *	Midrange Microcontrollers
 */

static volatile unsigned char	TMR0	@ 0x01;
static volatile unsigned char	PCL	@ 0x02;
static volatile unsigned char	STATUS	@ 0x03;
static 		unsigned char	FSR	@ 0x04;
static volatile unsigned char	PORTA	@ 0x05;
static volatile unsigned char	PORTB	@ 0x06;
#if defined(_16C557)
static volatile unsigned char	PORTC	@ 0x07;
#endif
static 		unsigned char 	PCLATH	@ 0x0A;
static volatile unsigned char	INTCON	@ 0x0B;

static 		unsigned char bank1	OPTION	@ 0x81;
static volatile	unsigned char bank1	TRISA	@ 0x85;
static volatile	unsigned char bank1	TRISB	@ 0x86;
#if defined(_16C557)
static volatile	unsigned char bank1	TRISC	@ 0x87;
#endif
static volatile unsigned char bank1	PCON	@ 0x8E;

/*	STATUS bits	*/
static volatile bit	RP0	@ (unsigned)&STATUS*8+5;
static volatile bit	TO	@ (unsigned)&STATUS*8+4;
static volatile bit	PD	@ (unsigned)&STATUS*8+3;
static volatile bit	ZERO	@ (unsigned)&STATUS*8+2;
static volatile bit	DC	@ (unsigned)&STATUS*8+1;
static volatile bit	CARRY	@ (unsigned)&STATUS*8+0;

/*	PORTA bits	*/
static volatile bit	RA4	@ (unsigned)&PORTA*8+4;
static volatile bit	RA3	@ (unsigned)&PORTA*8+3;
static volatile bit	RA2	@ (unsigned)&PORTA*8+2;
static volatile bit	RA1	@ (unsigned)&PORTA*8+1;
static volatile bit	RA0	@ (unsigned)&PORTA*8+0;

/*	PORTB bits	*/
static volatile bit 	RB7	@ (unsigned)&PORTB*8+7;
static volatile bit 	RB6	@ (unsigned)&PORTB*8+6;
static volatile bit 	RB5	@ (unsigned)&PORTB*8+5;
static volatile bit 	RB4	@ (unsigned)&PORTB*8+4;
static volatile bit 	RB3	@ (unsigned)&PORTB*8+3;
static volatile bit 	RB2	@ (unsigned)&PORTB*8+2;
static volatile bit 	RB1	@ (unsigned)&PORTB*8+1;
static volatile bit 	RB0	@ (unsigned)&PORTB*8+0;

#if defined(_16C557)
/*	PORTC bits	*/
static volatile bit 	RC7	@ (unsigned)&PORTC*8+7;
static volatile bit 	RC6	@ (unsigned)&PORTC*8+6;
static volatile bit 	RC5	@ (unsigned)&PORTC*8+5;
static volatile bit 	RC4	@ (unsigned)&PORTC*8+4;
static volatile bit 	RC3	@ (unsigned)&PORTC*8+3;
static volatile bit 	RC2	@ (unsigned)&PORTC*8+2;
static volatile bit 	RC1	@ (unsigned)&PORTC*8+1;
static volatile bit 	RC0	@ (unsigned)&PORTC*8+0;
#endif

/*	INTCON bits	*/
static volatile bit	GIE	@ (unsigned)&INTCON*8+7;
static volatile bit	T0IE	@ (unsigned)&INTCON*8+5;
static volatile bit	INTE	@ (unsigned)&INTCON*8+4;
static volatile bit	RBIE	@ (unsigned)&INTCON*8+3;
static volatile bit	T0IF	@ (unsigned)&INTCON*8+2;
static volatile bit	INTF	@ (unsigned)&INTCON*8+1;
static volatile bit	RBIF	@ (unsigned)&INTCON*8+0;

/*	OPTION bits	*/
static bank1 bit	RBPU	@ (unsigned)&OPTION*8+7;
static bank1 bit	INTEDG	@ (unsigned)&OPTION*8+6;
static bank1 bit	T0CS	@ (unsigned)&OPTION*8+5;
static bank1 bit	T0SE	@ (unsigned)&OPTION*8+4;
static bank1 bit	PSA	@ (unsigned)&OPTION*8+3;
static bank1 bit	PS2	@ (unsigned)&OPTION*8+2;
static bank1 bit	PS1	@ (unsigned)&OPTION*8+1;
static bank1 bit	PS0	@ (unsigned)&OPTION*8+0;

/*	TRISA bits	*/
static volatile bank1 bit	TRISA4	@ (unsigned)&TRISA*8+4;
static volatile bank1 bit	TRISA3	@ (unsigned)&TRISA*8+3;
static volatile bank1 bit	TRISA2	@ (unsigned)&TRISA*8+2;
static volatile bank1 bit	TRISA1	@ (unsigned)&TRISA*8+1;
static volatile bank1 bit	TRISA0	@ (unsigned)&TRISA*8+0;

/*	TRISB bits	*/
static volatile bank1 bit	TRISB7	@ (unsigned)&TRISB*8+7;
static volatile bank1 bit	TRISB6	@ (unsigned)&TRISB*8+6;
static volatile bank1 bit	TRISB5	@ (unsigned)&TRISB*8+5;
static volatile bank1 bit	TRISB4	@ (unsigned)&TRISB*8+4;
static volatile bank1 bit	TRISB3	@ (unsigned)&TRISB*8+3;
static volatile bank1 bit	TRISB2	@ (unsigned)&TRISB*8+2;
static volatile bank1 bit	TRISB1	@ (unsigned)&TRISB*8+1;
static volatile bank1 bit	TRISB0	@ (unsigned)&TRISB*8+0;

#if defined(_16C557)
/*	TRISC bits	*/
static volatile bank1 bit	TRISC7	@ (unsigned)&TRISC*8+7;
static volatile bank1 bit	TRISC6	@ (unsigned)&TRISC*8+6;
static volatile bank1 bit	TRISC5	@ (unsigned)&TRISC*8+5;
static volatile bank1 bit	TRISC4	@ (unsigned)&TRISC*8+4;
static volatile bank1 bit	TRISC3	@ (unsigned)&TRISC*8+3;
static volatile bank1 bit	TRISC2	@ (unsigned)&TRISC*8+2;
static volatile bank1 bit	TRISC1	@ (unsigned)&TRISC*8+1;
static volatile bank1 bit	TRISC0	@ (unsigned)&TRISC*8+0;
#endif

/*	PCON bits	*/
static volatile bank1 bit	POR	@ (unsigned)&PCON*8+1;

#define CONFIG_ADDR	0x2007

/*watchdog*/
#define WDTEN		0x3FFF	// enable watchdog timer
#define WDTDIS		0x3FFB	// disable watchdog timer

/*powr up timer*/
#define PWRTEN		0x3FF7	// enable power up timer
#define PWRTDIS		0x3FFF	// disable power up timer

/*osc configurations*/
#define RC		0x3FFF	// resistor/capacitor
#define HS		0x3FFE	// high speed crystal/oscillator
#define XT		0x3FFD	// crystal/oscillator
#define LP		0x3FFC	// low power crystal/oscillator

/* code protection */
#define UNPROTECT	0x3FFF	// do not protect code
#define PROTECT50	0x2AEF	// upper half program memory code protected
#define PROTECT75	0x15DF	// upper 3/4 program memory code protected
#define PROTECT		0x00CF	// all memory code is protected

