;	Byte multiplication for PIC 16C5x

#ifdef	_PIC12
	psect	text,class=ENTRY,delta=2
#else
	psect	text,class=CODE,delta=2
#endif

	global	abmul,lbmul
	global	abmul_t,lbmul_t

;	The main multiply thingo. Called with one operand in w and the
;	other in btemp+1. It really doesn't matter which one is where.
;	returns with the result in w (for 14 bit chips) or in btemp (for
;	12 bit chips)

#include	"sfr.h"

lbmul
abmul
	SELTEMP
	movwf	btemp		;Store multiplicand
lbmul_t
abmul_t				;enter here with operand in btemp
#ifdef	_PIC12
	clrf	FSR
#endif
	SELTEMP
	movlw	0		;initialize product
loop
	btfsc	plier,0		;skip if multiplier lsb not set
	addwf	btemp,w		;add multiplicand
	bcf	STATUS,C	;clear carry
	rlf	btemp		;shift multiplicand up
	bcf	STATUS,C	;clear carry again
	rrf	plier		;shift multiplier down
#ifdef	_PIC16
	tstfsz	plier
#else
	movf	plier		;test it
	btfss	STATUS,Z	;test for early return
#endif
	goto	loop
#ifdef	_PIC12
	movwf	btemp		;store product
	retlw	0		;done, result in btemp
#else
	return
#endif

        psect   temp,global,class=BANK0,space=1,ovrld
btemp	ds	1
plier	ds	1

	global	used_btemp0
	global	used_btemp1
	end
