;	Copyright (C) 1997 HI-TECH Software 

;	Single Precision IEEE Floating point arithmetic routines for PIC
;	The 32 bit IEEE format is referred to as 'double'.

;	The format of floating point numbers is as follows:

;	-----------------
;	*   mantissa	*  23 bits + 1 implied bit = 24 bits
;	-----------------
;	*   exponent	*  8 bits
;	-----------------
;	*     sign	*  1 bit
;	-----------------

;	The implied bit is always 1 except for a zero value where it is
;	zero. A zero value is indicated by a zero exponent. The exponent
;	for a float is stored as excess 127 (i.e. an exponent of 0 is
;	represented by 127). The mantissa is in positive magnitude form.

;	The memory layout has the least significant
;	byte (i.e. that containing LSB of the mantissa) coming first, i.e. at the
;	lowest address.

;	Calling conventions:

;	Left operand in btemp, right operand in btemp+4
;
;	Return value is in btemp+8 mostly

;	Naming conventions: A routine name is constructed by

;	      ASOP

;	Where A is the arithmetic type (f for float), and op is the operation,
;	one of mul, div, mod, add, sub and cmp. S is the size, always d for double.
;	Conversion routines are named

;		AStod

;	where A is the arithmetic type (a for integer, l for unsigned)
;	S is the integer size, one of b (byte), w (word) or l (long).
;	Conversion from double to integer is dtol.

;	Useful macro

;	Add a 4 byte quantity to another 4 byte quantity

;add4	macro	src,dst
;	movf	src,w
;	addwf	dst
;	movf	src+1,w
;	btfsc	3,0
;	incfsz	src+1,w
;	addwf	dst+1
;	movf	src+2,w
;	btfsc	3,0
;	incfsz	src+2,w
;	addwf	dst+2
;	movf	src+3,w
;	btfsc	3,0
;	incf	src+3,w
;	addwf	dst+3
;	endm
;	
;
;shr4	macro	dst
;	bcf	3,0
;	rrf	dst+3
;	rrf	dst+2
;	rrf	dst+1
;	rrf	dst
;	endm
;
;shr3	macro	dst
;	bcf	3,0
;	rrf	dst+2
;	rrf	dst+1
;	rrf	dst
;	endm
;
;shl4	macro	dst
;	bcf	3,0
;	rlf	dst
;	rlf	dst+1
;	rlf	dst+2
;	rlf	dst+3
;	endm
;	
;shl3	macro	dst
;	bcf	3,0
;	rlf	dst
;	rlf	dst+1
;	rlf	dst+2
;	endm

	global	flunpack1, flunpack2, flnorm1, zerct
	

;	re-use memory for things

        psect   temp,ovrld,class=BANK0,space=1
mant1
btemp  ds     12
mant2 equ	btemp+4
cntr	equ	mant2+3		;use the high byte of mant2 as a counter byte
prod	equ	btemp+8

        psect   xtemp,ovrld,class=BANK0,space=1
exp1	ds	1
exp2	ds	1
signs	ds	1


	global	used_btemp0
	global	used_btemp1
	global	used_btemp2
	global	used_btemp3
	global	used_btemp4
	global	used_btemp5
	global	used_btemp6
	global	used_btemp7
	global	used_btemp8
	global	used_btemp9
	global	used_btemp10
	global	used_btemp11
	global	used_btemp12
	global	used_btemp13
	global	used_btemp14


#include	"sfr.h"

#ifdef	_PIC12
#define	return	retlw	0
	psect	float_text0,class=ENTRY,delta=2,size=512
	psect	ftext,class=ENTRY,delta=2,local,with=float_text0
#else
	psect	float_text0,class=CODE,delta=2
#endif

