#if defined _PIC16
#include	"fastdbl.h"

SETFOV32        BSF             FPFLAGS,FOV             ; set floating point underflag
		RLCF 		AARGB0,F		; PIC to IEEE
		RRCF 		AEXP,F
		RRCF 		AARGB0,F

                ;BTFSS           FPFLAGS,SAT             ; test for saturation (on by default)
                ;goto		storeback  

                SETF            AEXP,F			; saturate to largest floating
                SETF            AARGB0,F                ; point number = 0x 7F FF FF FF
                SETF            AARGB1,F		; modulo the appropriate sign bit
                SETF            AARGB2,F
                RLCF            SIGN,F
                RRCF            AEXP,F
		goto		storeback  


SETFUN32        BSF             FPFLAGS,FUN             ; set floating point underflag
		RLCF 		AARGB0,F		; PIC to IEEE
		RRCF 		AEXP,F
		RRCF 		AARGB0,F

                ;BTFSS           FPFLAGS,SAT             ; test for saturation (on by default)
		;goto		storeback  

                MOVLW           0x80                    ; saturate to smallest floating
                MOVPF           WREG, AARGB0            ; point number = 0x 00 80 00 00
                CLRF            AEXP ,F			; modulo the appropriate sign bit
                CLRF            AARGB1,F
                CLRF            AARGB2,F
                RLCF            SIGN,F
                RRCF            AEXP,F
		goto		storeback  


SETFDZ32        BSF             FPFLAGS,FDZ             ; set floating point divide by zero

                SETF            AEXP,F			; saturate to largest floating
                SETF            AARGB0,F                ; point number = 0x 7F FF FF FF
                SETF            AARGB1,F		; modulo the appropriate sign bit
                SETF            AARGB2,F
                RLCF            SIGN,F
                RRCF            AEXP,F
		goto		storeback  

RES032          CLRF            AARGB0		; result equals zero
                CLRF            AARGB1
                CLRF            AARGB2
		CLRF		AARGB3		; clear extended byte
                CLRF            EXP
		goto		storeback  

;****************************************************************************
;			Set FP Flags
;****************************************************************************

_set_fpflags
		MOVLR		0			; Select Bank 0
		MOVPF		WREG, FPFLAGS
		RETURN


;****************************************************************************
;			Get FP Flags
;****************************************************************************

_get_fpflags
		MOVLR		0			; Select Bank 0
		MOVFP		FPFLAGS, WREG 
		RETURN

#endif
