;	Copyright (C) 1997 HI-TECH Software 

;	Single Precision IEEE Floating point arithmetic routines for PIC
;	Addition done here


#include	"double.h"

	global	fladd,flsub,fladd_x
	global	flunpack1,flunpack2,fldenorm
	global	l0neg

	FNCALL	fladd,flunpack1
	FNCALL	fladd,flunpack2
	FNCALL	fladd,fldenorm
	FNCALL	fladd,l0neg
	FNCALL	fladd_x,flunpack1
	FNCALL	fladd_x,flunpack2
	FNCALL	fladd_x,fldenorm
	FNCALL	fladd_x,l0neg
	FNCALL	flsub,flunpack1
	FNCALL	flsub,flunpack2
	FNCALL	flsub,fldenorm
	FNCALL	flsub,l0neg

;	fpdenorm - denormalize one of the two operands so that their
;	exponents are equal. This requires the smaller number to have
;	its exponent incremented and its mantissa shifted right.

fldenorm
	movf	exp1,w
	subwf	exp2,w		;compare exponents
	btfss	STATUS,C
	goto	up2		;shift operand 2
#ifndef	_PIC12
	addlw	-24		;check for out of range
	btfss	STATUS,C	;if carry set, it's out of range
	goto	up1a
	clrf	mant1+2
	clrf	mant1+1
	clrf	mant1+0
	movf	exp2,w		;copy exponent
	movwf	exp1
	return			;done
#endif
	
up1a
	movf	exp1,w		;subtract again
	subwf	exp2,w
	btfsc	STATUS,Z	;equal now?
	return
#ifndef	_PIC12
	addlw	-8
	btfss	STATUS,C
	goto	up1b
	movlw	8
	addwf	exp1		;update exponent
	movf	mant1+1,w
	movwf	mant1+0
	movf	mant1+2,w
	movwf	mant1+1
	clrf	mant1+2
	goto	up1a
up1b
#else
	bcf	STATUS,C
#endif	/* _PIC12 */
	rrf	mant1+3
	rrf	mant1+2
	rrf	mant1+1
	rrf	mant1+0
	incf	exp1
	goto	up1a

up2
#ifndef	_PIC12
	movf	exp2,w
	subwf	exp1,w
	addlw	-24		;check for range
	btfss	STATUS,C
	goto	up2a
	clrf	mant2+2
	clrf	mant2+1
	clrf	mant2+0
	return
#endif
up2a
	movf	exp2,w
	subwf	exp1,w
	btfsc	STATUS,Z
	return
#ifndef	_PIC12
	addlw	-8
	btfss	STATUS,C
	goto	up2b
	movlw	8
	addwf	exp2		;update exponent
	movf	mant2+1,w
	movwf	mant2+0
	movf	mant2+2,w
	movwf	mant2+1
	clrf	mant2+2
	goto	up2a
up2b
#else
	bcf	STATUS,C
#endif
	rrf	mant2+3
	rrf	mant2+2
	rrf	mant2+1
	rrf	mant2+0
	incf	exp2
	goto	up2a

;	subtract two numbers

flsub
	SELTEMP
	movlw	80h
	xorwf	mant2+3		;toggle sign of the RHS

;	fall through

;	Add the number in op1 to the number in op2 and return the result in ctemp


fladd
	clrf	FSR
fladd_x
	call	flunpack1
	call	flunpack2
	call	fldenorm
	btfss	signs,0		;check sign of LHS
	goto	add1		;positive, leave alone
	call	l0neg		;negate it
add1:
	
	btfss	signs,1		;check sign of RHS
	goto	add2		;positive, leave alone
	comf	mant2		;negate it - complement and add 1
	comf	mant2+1
	comf	mant2+2
	comf	mant2+3
	incf	mant2
	btfsc	STATUS,Z
	incf	mant2+1
	btfsc	STATUS,Z
	incf	mant2+2
	btfsc	STATUS,Z
	incf	mant2+3
add2:
	movf	mant2,w		;add the mantissas
	addwf	mant1
	movf	mant2+1,w
	btfsc	STATUS,0
	incfsz	mant2+1,w
	addwf	mant1+1
	movf	mant2+2,w
	btfsc	STATUS,0
	incfsz	mant2+2,w
	addwf	mant1+2
	movf	mant2+3,w
	btfsc	STATUS,0
	incf	mant2+3,w
	addwf	mant1+3
	clrf	signs		;clear the result sign
	btfss	mant1+3,7	;test the sign of the sum
	goto	add3		;positive, leave as is
	call	l0neg		;negate it
	bsf	signs,0		;set sign bit
add3:
	goto	flnorm1		;finished, reformat it and return

	end
