;	Copyright (C) 1997 HI-TECH Software 

#include	"float.h"

	global	storeback_3

;	unpack1 - unpacks the left operand. It is in btemp+0

#ifdef	_PIC12
	psect	ftext0,local,class=ENTRY,delta=2,with=float_text4
#endif
ftunpack1
	SELTEMP
	clrf	signs		;zero sign bits
	rlf	mant1+1,w	;get LS bit of exponent
	rlf	mant1+2,w	;rotate into the exponent
	movwf	exp1		;store exponent
#ifdef _PIC16
	iorlw	0		;test for zero
#else
	movf	exp1,w
#endif
	btfsc	STATUS,Z	;skip if non-zero
	goto	zerctt		;all zero, go away
	rlf	signs		;put sign bit in LSB of signs
	clrf	mant1+2		;clear MS byte of mantissa
	bsf	mant1+1,7	;set hidden bit
	return

;	Utility routines
zerctt
	clrf	mant1+0
	clrf	mant1+1
	clrf	mant1+2
	retlw	0

;	unpack2 - unpacks right operand

#ifdef	_PIC12
	psect	ftext1,local,class=ENTRY,delta=2,with=float_text4
#endif
ftunpack2
	bcf	signs,1		;zero sign bit
	rlf	mant2+1,w	;get LS bit of exponent
	rlf	mant2+2,w	;rotate into the exponent
	movwf	exp2		;store exponent
#ifdef	_PIC16
	iorlw	0		;test for zero
#else
	movf	exp2,w
#endif
	btfsc	STATUS,Z	;skip if non-zero
	goto	zer2		;all zero, go away
	btfsc	STATUS,C	;test sign bit
	bsf	signs,1
	clrf	mant2+2		;clear MS byte of mantissa
	bsf	mant2+1,7	;set hidden bit
	return

zer2
	clrf	exp2
	clrf	mant2
	clrf	mant2+1
	clrf	mant2+2
	return

;	pack1 - put operand 1 back into float format

pack1
	movf	exp1,w		;get exponent
#ifdef	_PIC16
	iorlw	0		;set flags
#endif
	btfsc	STATUS,Z	;if exponent zero, then whole number is zero
	goto	zerctt
	bcf	mant1+1,7	;reset hidden bit
	rrf	signs		;get sign bit into carry
	rrf	exp1,w		;rotate into exponent
	movwf	mant1+2		;store exponent
	btfsc	STATUS,C	;check LS bit
	bsf	mant1+1,7	;set LS bit of exponent
	goto	storeback_3

;	norm1 - normalize the unpacked value in 1 and repack it

#ifdef	_PIC12
	psect	ftext2,local,class=CODE,delta=2,with=float_text4
#endif
ftnorm1
#ifdef	_PIC16
	tstfsz	exp1
#else
	movf	exp1		;test for zero exponent
	btfss	STATUS,Z	;if zero, all is zero
#endif
	goto	norup		;go normalize up
zerores
	clrf	mant1+0		;zero the mantissa if all zero
	clrf	mant1+1
	clrf	mant1+2
	goto	storeback_3

nordn
	decf	mant1+2,w	;check for == 1
	btfsc	STATUS,Z
	incf	mant1+0		;add one for rounding
	btfsc	STATUS,Z
	incf	mant1+1		;add one for rounding
	btfsc	STATUS,Z
	incf	mant1+2		;add one for rounding
1:
	bcf	STATUS,C	;shift in a zero
	rrf	mant1+2		;rotate down one bit
	rrf	mant1+1		;rotate down one bit
	rrf	mant1+0		;rotate down one bit
	incf	exp1		;increment exponent
	goto	ftnorm1

norup
#ifdef	_PIC16
	tstfsz	mant1+2
#else
	movf	mant1+2		;test top byte
	btfss	STATUS,Z	;if non-zero, normalize down
#endif
	goto	nordn
	movf	mant1+0,w	;test for zero mantissa
	iorwf	mant1+1,w
	btfsc	STATUS,Z
	goto	zerores		;zero everything
norup1
	btfsc	mant1+1,7	;test top bit
	goto	pack1		;set, go pack it up
	decf	exp1		;decrement exponent
	btfsc	STATUS,Z
	goto	zerores		;zero everything
	bcf	STATUS,C
	rlf	mant1+0
	rlf	mant1+1
	goto	norup1


	end
