;	Copyright (C) 1997 HI-TECH Software 

;	Single Precision IEEE Floating point arithmetic routines for PIC
;	The 24 bit modified IEEE format is referred to as 'single'.

;	The format of floating point numbers is as follows:

;	-----------------
;	*   mantissa	*  15 bits + 1 implied bit = 16 bits
;	-----------------
;	*   exponent	*  8 bits
;	-----------------
;	*     sign	*  1 bit
;	-----------------

;	The implied bit is always 1 except for a zero value where it is
;	zero. A zero value is indicated by a zero exponent. The exponent
;	for a float is stored as excess 127 (i.e. an exponent of 0 is
;	represented by 127). The mantissa is in positive magnitude form.

;	The memory layout has the least significant
;	byte (i.e. that containing LSB of the mantissa) coming first, i.e. at the
;	lowest address.

;	Calling conventions:

;	Left operand in btemp, right operand in btemp+4
;
;	Naming conventions: A routine name is constructed by

;	      ASOP

;	Where A is the arithmetic type (f for float), and op is the operation,
;	one of mul, div, mod, add, sub and cmp. S is the size, always d for double.
;	Conversion routines are named

;		AStod

;	where A is the arithmetic type (a for integer, l for unsigned)
;	S is the integer size, one of b (byte), w (word) or l (long).
;	Conversion from double to integer is dtol.

;	Useful macro


	global	ftunpack1, ftunpack2, ftnorm1, zerctt
	

;	re-use memory for things

        psect   temp,ovrld,class=BANK0,space=1
mant1
btemp  ds     3

	global	used_btemp0
	global	used_btemp1
	global	used_btemp2
	global	used_btemp3
	global	used_btemp4
	global	used_btemp5
	global	used_btemp6
	global	used_btemp7
	global	used_btemp8

mant2 	ds	3
cntr	equ	mant2+2		;use the high byte of mant2 as a counter byte
exp1	ds	1
exp2	ds	1
signs	ds	1

#include "sfr.h"

/*C       equ     0
Z       equ     2

#ifdef	_PIC16
INDF	equ	0
FSR	equ	1
STATUS	equ	4
TBLPTRL	equ	0Dh
TBLPTRH	equ	0Eh
WREG	equ	0Ah
BSR	equ	0Fh
#else
STATUS	equ	3
FSR	equ	4
INDF	equ	0
#endif */

#ifdef	_PIC12
#define	return	retlw	0
	psect	float_text4,class=ENTRY,delta=2,size=512
	psect	ftext,class=ENTRY,delta=2,local,with=float_text4
#else
	psect	float_text4,class=CODE,delta=2
#endif

;	A macro to ensure temp area is accessible
