;	Copyright (C) 1997 HI-TECH Software 

;	Single Precision IEEE Floating point arithmetic routines for PIC
;	Addition done here


#include	"float.h"

	global	ftadd,ftsub,ftadd_x
	global	ftunpack1,ftunpack2,ftdenorm
	FNCALL	ftadd,ftunpack1
	FNCALL	ftadd,ftunpack2
	FNCALL	ftadd,ftdenorm
	FNCALL	ftadd_x,ftunpack1
	FNCALL	ftadd_x,ftunpack2
	FNCALL	ftadd_x,ftdenorm
	FNCALL	ftsub,ftunpack1
	FNCALL	ftsub,ftunpack2
	FNCALL	ftsub,ftdenorm

;	fpdenorm - denormalize one of the two operands so that their
;	exponents are equal. This requires the smaller number to have
;	its exponent incremented and its mantissa shifted right.

#ifdef	_PIC12
	psect	ftext0,local,class=ENTRY,delta=2,with=float_text4
#endif
ftdenorm
	movf	exp1,w
	subwf	exp2,w		;compare exponents
	btfss	STATUS,C
	goto	up2		;shift operand 2
up1a
	btfsc	STATUS,Z	;equal now?
	return
	bcf	STATUS,C
	rrf	mant1+2
	rrf	mant1+1
	rrf	mant1+0
	incf	exp1
	movf	exp1,w
	subwf	exp2,w
	goto	up1a

up2
	bcf	STATUS,C
	rrf	mant2+2
	rrf	mant2+1
	rrf	mant2+0
	incf	exp2
	movf	exp1,w
	xorwf	exp2,w
	btfsc	STATUS,Z
	return
	goto	up2

;	subtract two numbers

#ifdef	_PIC12
	psect	ftext1,local,class=ENTRY,delta=2,with=float_text4
#endif
ftsub
	SELTEMP
	movlw	80h
	xorwf	mant2+2		;toggle sign of the RHS
#ifdef	_PIC12
	goto	ftadd
#endif


;	Add the number in op1 to the number in op2 and return the result in ctemp


#ifdef	_PIC12
	psect	ftext2,local,class=ENTRY,delta=2,with=float_text4
#endif
ftadd
	clrf	FSR
ftadd_x
	call	ftunpack1
	call	ftunpack2
	call	ftdenorm
	btfss	signs,0		;check sign of LHS
	goto	add1		;positive, leave alone
	comf	mant1		;negate it - complement and add 1
	comf	mant1+1
	comf	mant1+2
	incf	mant1
	btfsc	STATUS,Z
	incf	mant1+1
	btfsc	STATUS,Z
	incf	mant1+2
add1:
	
	btfss	signs,1		;check sign of RHS
	goto	add2		;positive, leave alone
	comf	mant2		;negate it - complement and add 1
	comf	mant2+1
	comf	mant2+2
	incf	mant2
	btfsc	STATUS,Z
	incf	mant2+1
	btfsc	STATUS,Z
	incf	mant2+2
#ifdef	_PIC12
	goto	add2
	psect	ftext4,local,class=CODE,delta=2,with=float_text4
#endif

add2:
	movf	mant2,w		;add the mantissas
	addwf	mant1
	movf	mant2+1,w
	btfsc	STATUS,0
	incfsz	mant2+1,w
	addwf	mant1+1
	movf	mant2+2,w
	btfsc	STATUS,0
	incfsz	mant2+2,w
	addwf	mant1+2
	clrf	signs		;clear the result sign
	btfss	mant1+2,7	;test the sign of the sum
	goto	ftnorm1		;positive, leave as is
	comf	mant1		;negate it - complement and add 1
	comf	mant1+1
	comf	mant1+2
	incf	mant1
	btfsc	STATUS,Z
	incf	mant1+1
	btfsc	STATUS,Z
	incf	mant1+2
	bsf	signs,0		;set the sign bit
	goto	ftnorm1		;finished, reformat it and return

	end
