	global	?_ldexp
	global	_ldexp
	FNSIZE	_ldexp,4,6
#if	sizeof(double) == 4
	signat	_ldexp,8308
	#define	MSIZE	4
#else
	signat	_ldexp,8307
	#define	MSIZE	3
#endif
	global	used_btemp0
	global	used_btemp1
	global	used_btemp2
#if	MSIZE == 4
	global	used_btemp3
#endif
	psect	text0,local,class=CODE,delta=2

#include "sfr.h"

_ldexp:
#ifdef _PIC16
	movlr	0h
#else
	clrf	STATUS	;select bank 0, clear other status bits
#endif

; extract the old/current exponen
	rlf	(?_ldexp+MSIZE-2)&0xff,w	; just get the exponent LSB into CARRY
	rlf	(?_ldexp+MSIZE-1)&0xff,w	; get the 8-Bit exponent into WREG
#ifdef _PIC12
	movwf	btemp
	movlw	129
	addwf	btemp,w
#else
	addlw	129			; convert to regular form (non-excess 127)
#endif
; add the old exponent to the new 
	movwf	btemp
	addwf	(?_ldexp+MSIZE)&0xff,f	; add old exponent to new
	btfsc	STATUS,C		; if the addition had a carry
	incf	(?_ldexp+MSIZE+1)&0xff	; increment upper byte
	btfsc	btemp,7			; if real exponent is negative
	decf	(?_ldexp+MSIZE+1)&0xff	; add 0xFF (upper byte)
; we have now summed the exponents, do bounds checking
	movlw	0
	btfsc	(?_ldexp+MSIZE+1)&0xff, 7
	movlw	1
	addwf	(?_ldexp+MSIZE+1)&0xff,w	; If bounds are correct, this operation will be either (00h + 0) or (FFh + 1)
	btfss	STATUS,Z
	goto	overflowCondition	; if the result isn't zero, the above operation is untrue - overflow
; Result is within valid range, Yay!
	movf	(?_ldexp+MSIZE)&0xff,w		; collect new exponent
#ifdef _PIC12
	movwf 	btemp
	movlw	127
	addwf	btemp,w
#else
	addlw	127			; revert to excess 127 mode
#endif
	movwf	btemp+MSIZE-1		; tentatively place the exponent (needs right shift yet)
	movf	?_ldexp,w		; this byte won't change
	movwf	btemp
#if	MSIZE == 4
	movf	?_ldexp+1,w		; nor will this bit
	movwf	btemp+1			
#endif
	rlf	(?_ldexp+MSIZE-2)&0xff,w	; get the uppermost byte of mantissa
	movwf	btemp+MSIZE-2		; tentatively place it at output - needs RShift and the LSB of exponent
	rlf	(?_ldexp+MSIZE-1)&0xff,f	; pickup sign bit
	rrf	btemp+MSIZE-1,f		; roll in sign bit, roll out the exponent LSB
	rrf	btemp+MSIZE-2,f		; roll in exponent's LSB (from CARRY)
; value has been updated, return it now
	return				; now everyone's happy	

overflowCondition:
	btfss	(?_ldexp+MSIZE+1)&0xff,7	; how did it fail?
	goto	resultTooBig		; exponent was overly positive
	clrf	btemp			; exponent was overly negative - return zero
	clrf	btemp+1
	clrf	btemp+2
#if	MSIZE == 4
	clrf	btemp+3
#endif
	return
resultTooBig:				; return either +MAX or -MAX
	movlw	0xff
	movwf	btemp
	movwf	btemp+1
	movwf	btemp+2
#if	MSIZE == 4
	movwf	btemp+3
#endif
	bcf	btemp+MSIZE-2,7
	btfss	(?_ldexp+MSIZE+1)&0xff,7	; figure out the correct signage of the result
	bcf	btemp+MSIZE-1,7		
	return

	psect	temp,global,ovrld,class=BANK0,space=1
btemp:
	ds	MSIZE
