;	Long multiplication for PIC 16C5x

#ifdef	_PIC12
	psect	float_text0,class=ENTRY,delta=2,size=512
	psect	ftext,local,class=ENTRY,delta=2,with=float_text0
#else
	psect	float_text0,class=CODE,delta=2
#endif

	global	almul,llmul,llmul_x,almul_x,storeback

;	The main multiply thingo. Called with one operand in btemp+0 and the
;	other in btemp+4. It really doesn't matter which one is where.
;	The multiplier is copied to plier, and the product built up in
;	acca where it belongs

#include	"sfr.h"

llmul
almul
	clrf	FSR
llmul_x
almul_x
	SELTEMP
	movf	prod+0,w
	movwf	plier+0
	movf	prod+1,w
	movwf	plier+1
	movf	prod+2,w
	movwf	plier+2
	movf	prod+3,w
	movwf	plier+3
	clrf	prod+2
	clrf	prod+3
#if	defined(_PIC16) && !defined(_17C42)
	movf	plier,w		;get the multiplier low byte
	mulwf	btemp		;multiply by low byte
	movpf	PRODL,prod	;save product, 16 bits
	movpf	PRODH,prod+1
;--------
	movf	plier,w		;get the multiplier low byte
	mulwf	btemp+1		;multiply by next byte
	movf	PRODL,w
	addwf	prod+1		;add to result
	movf	PRODH,w
	addwfc	prod+2

	movf	plier+1,w	;get the multiplier high byte
	mulwf	btemp		;multiply by low byte
	movf	PRODL,w
	addwf	prod+1		;add to result hi byte
	movf	PRODH,w
	addwfc	prod+2
	btfsc	STATUS,0	;carry?
	incf	prod+3		;add in
;---------
	movf	plier+0,w	;get the multiplier
	mulwf	btemp+2		;multiply by another byte
	movf	PRODL,w
	addwf	prod+2		;add to result
	movf	PRODH,w
	addwfc	prod+3

	movf	plier+1,w	;get the multiplier
	mulwf	btemp+1		;multiply by another byte
	movf	PRODL,w
	addwf	prod+2		;add to result
	movf	PRODH,w
	addwfc	prod+3

	movf	plier+2,w	;get the multiplier
	mulwf	btemp+0		;multiply by another byte
	movf	PRODL,w
	addwf	prod+2		;add to result
	movf	PRODH,w
	addwfc	prod+3
;-----------
	movf	plier+0,w	;get the multiplier
	mulwf	btemp+3		;multiply by another byte
	movf	PRODL,w
	addwf	prod+3		;add to result

	movf	plier+1,w	;get the multiplier
	mulwf	btemp+2		;multiply by another byte
	movf	PRODL,w
	addwf	prod+3		;add to result

	movf	plier+2,w	;get the multiplier
	mulwf	btemp+1		;multiply by another byte
	movf	PRODL,w
	addwf	prod+3		;add to result

	movf	plier+3,w	;get the multiplier
	mulwf	btemp+0		;multiply by another byte
	movf	PRODL,w
	addwf	prod+3		;add to result
;-----------
	goto	storeback	;done already!

#else
	clrf	prod		;initialize product
	clrf	prod+1
loop
	bcf	STATUS,C
	rrf	plier+3		;shift multiplier down
	rrf	plier+2
	rrf	plier+1
	rrf	plier
	btfss	STATUS,C	;skip if multiplier lsb not set
	goto	lop1
	movf	btemp,w		;add multiplicand to product
	addwf	prod
	movf	btemp+1,w
	btfsc	STATUS,C
	incfsz	btemp+1,w
	addwf	prod+1
	movf	btemp+2,w
	btfsc	STATUS,C
	incfsz	btemp+2,w
	addwf	prod+2
	movf	btemp+3,w
	btfsc	STATUS,C
	incfsz	btemp+3,w
	addwf	prod+3
lop1
	movf	plier+0,w	;test multiplier for zero
	iorwf	plier+1,w
	iorwf	plier+2,w
	iorwf	plier+3,w
	btfsc	STATUS,Z
	goto	storeback
	bcf	STATUS,C	;clear carry
	rlf	btemp		;shift multiplicand up
	rlf	btemp+1
	rlf	btemp+2
	rlf	btemp+3
	goto	loop
#endif

        psect   temp,global,class=BANK0,space=1,ovrld
prod	ds	4
btemp	ds	4
plier	ds	4

	global	used_btemp0
	global	used_btemp1
	global	used_btemp2
	global	used_btemp3
	global	used_btemp4
	global	used_btemp5
	global	used_btemp6
	global	used_btemp7
	global	used_btemp8
	global	used_btemp9
	global	used_btemp10
	global	used_btemp11

	end
