#include	<math.h>
#include	<errno.h>

double
sqrt(double x)
{
	double	og, ng;
	short	niter;
	int	expon;

	if(x < 0.0) {
		errno = EDOM;
		return 0.0;
	}
	if(x == 0.0) {
		return 0.0;
	}
	og = x;
	if(og < 1.0)
		og = 1.0/og;
	og = frexp(og, &expon);
	og = ldexp(og, expon/2);		/* make an educated guess */
	if(x < 1.0)
		og = 1.0/og;
	niter = 20;
	do {
		ng = (x/og + og)/2.0;
		if(ng == og)
			break;
		og = ng;
	} while(--niter);
	return og;
}
